/*
 * Created by the DBAccessor generator.
 * Programmer: Lennart Martens
 * Date: 08/08/2012
 * Time: 21:02:47
 */
package com.compomics.proteocloud.db.accessor;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;

import com.compomics.util.db.interfaces.Deleteable;
import com.compomics.util.db.interfaces.Persistable;
import com.compomics.util.db.interfaces.Retrievable;
import com.compomics.util.db.interfaces.Updateable;

/*
 * CVS information:
 *
 * $Revision: 1.4 $
 * $Date: 2007/07/06 09:41:53 $
 */

/**
 * This class is a generated accessor for the Taxon table.
 *
 * @author DBAccessor generator class (Lennart Martens).
 */
public class TaxonTableAccessor implements Deleteable, Retrievable, Updateable, Persistable {

	/**
	 * This variable tracks changes to the object.
	 */
	protected boolean iUpdated = false;

	/**
	 * This variable can hold generated primary key columns.
	 */
	protected Object[] iKeys = null;

	/**
	 * This variable represents the contents for the 'taxonid' column.
	 */
	protected long iTaxonid = Long.MIN_VALUE;


	/**
	 * This variable represents the contents for the 'species' column.
	 */
	protected String iSpecies = null;


	/**
	 * This variable represents the contents for the 'filename' column.
	 */
	protected String iFilename = null;


	/**
	 * This variable represents the key for the 'taxonid' column.
	 */
	public static final String TAXONID = "TAXONID";

	/**
	 * This variable represents the key for the 'species' column.
	 */
	public static final String SPECIES = "SPECIES";

	/**
	 * This variable represents the key for the 'filename' column.
	 */
	public static final String FILENAME = "FILENAME";




	/**
	 * Default constructor.
	 */
	public TaxonTableAccessor() {
	}

	/**
	 * This constructor allows the creation of the 'TaxonTableAccessor' object based on a set of values in the HashMap.
	 *
	 * @param	aParams	HashMap with the parameters to initialize this object with.
	 *		<i>Please use only constants defined on this class as keys in the HashMap!</i>
	 */
	public TaxonTableAccessor(HashMap aParams) {
		if(aParams.containsKey(TAXONID)) {
			this.iTaxonid = ((Long)aParams.get(TAXONID)).longValue();
		}
		if(aParams.containsKey(SPECIES)) {
			this.iSpecies = (String)aParams.get(SPECIES);
		}
		if(aParams.containsKey(FILENAME)) {
			this.iFilename = (String)aParams.get(FILENAME);
		}
		this.iUpdated = true;
	}


	/**
	 * This constructor allows the creation of the 'TaxonTableAccessor' object based on a resultset
	 * obtained by a 'select * from Taxon' query.
	 *
	 * @param	aResultSet	ResultSet with the required columns to initialize this object with.
	 * @exception	SQLException	when the ResultSet could not be read.
	 */
	public TaxonTableAccessor(ResultSet aResultSet) throws SQLException {
		this.iTaxonid = aResultSet.getLong("taxonid");
		this.iSpecies = (String)aResultSet.getObject("species");
		this.iFilename = (String)aResultSet.getObject("filename");

		this.iUpdated = true;
	}


	/**
	 * This method returns the value for the 'Taxonid' column
	 * 
	 * @return	long	with the value for the Taxonid column.
	 */
	public long getTaxonid() {
		return this.iTaxonid;
	}

	/**
	 * This method returns the value for the 'Species' column
	 * 
	 * @return	String	with the value for the Species column.
	 */
	public String getSpecies() {
		return this.iSpecies;
	}

	/**
	 * This method returns the value for the 'Filename' column
	 * 
	 * @return	String	with the value for the Filename column.
	 */
	public String getFilename() {
		return this.iFilename;
	}

	/**
	 * This method sets the value for the 'Taxonid' column
	 * 
	 * @param	aTaxonid	long with the value for the Taxonid column.
	 */
	public void setTaxonid(long aTaxonid) {
		this.iTaxonid = aTaxonid;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Species' column
	 * 
	 * @param	aSpecies	String with the value for the Species column.
	 */
	public void setSpecies(String aSpecies) {
		this.iSpecies = aSpecies;
		this.iUpdated = true;
	}

	/**
	 * This method sets the value for the 'Filename' column
	 * 
	 * @param	aFilename	String with the value for the Filename column.
	 */
	public void setFilename(String aFilename) {
		this.iFilename = aFilename;
		this.iUpdated = true;
	}



	/**
	 * This method allows the caller to delete the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int delete(Connection aConn) throws SQLException {
		PreparedStatement lStat = aConn.prepareStatement("DELETE FROM taxon WHERE taxonid = ?");
		lStat.setLong(1, iTaxonid);
		int result = lStat.executeUpdate();
		lStat.close();
		return result;
	}


	/**
	 * This method allows the caller to read data for this
	 * object from a persistent store based on the specified keys.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public void retrieve(Connection aConn, HashMap aKeys) throws SQLException {
		// First check to see whether all PK fields are present.
		if(!aKeys.containsKey(TAXONID)) {
			throw new IllegalArgumentException("Primary key field 'TAXONID' is missing in HashMap!");
		} else {
			iTaxonid = ((Long)aKeys.get(TAXONID)).longValue();
		}
		// In getting here, we probably have all we need to continue. So let's...
		PreparedStatement lStat = aConn.prepareStatement("SELECT * FROM taxon WHERE taxonid = ?");
		lStat.setLong(1, iTaxonid);
		ResultSet lRS = lStat.executeQuery();
		int hits = 0;
		while(lRS.next()) {
			hits++;
			iTaxonid = lRS.getLong("taxonid");
			iSpecies = (String)lRS.getObject("species");
			iFilename = (String)lRS.getObject("filename");
		}
		lRS.close();
		lStat.close();
		if(hits>1) {
			throw new SQLException("More than one hit found for the specified primary keys in the 'taxon' table! Object is initialized to last row returned.");
		} else if(hits == 0) {
			throw new SQLException("No hits found for the specified primary keys in the 'taxon' table! Object is not initialized correctly!");
		}
	}
	/**
	 * This method allows the caller to obtain a basic select for this table.
	 *
	 * @return   String with the basic select statement for this table.
	 */
	public static String getBasicSelect(){
		return "select * from taxon";
	}

	/**
	 * This method allows the caller to obtain all rows for this
	 * table from a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 * @return   ArrayList<TaxonTableAccessor>   with all entries for this table.
	 */
	public static ArrayList<TaxonTableAccessor> retrieveAllEntries(Connection aConn) throws SQLException {
		ArrayList<TaxonTableAccessor>  entities = new ArrayList<TaxonTableAccessor>();
		Statement stat = aConn.createStatement();
		ResultSet rs = stat.executeQuery(getBasicSelect());
		while(rs.next()) {
			entities.add(new TaxonTableAccessor(rs));
		}
		rs.close();
		stat.close();
		return entities;
	}



	/**
	 * This method allows the caller to update the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int update(Connection aConn) throws SQLException {
		if(!this.iUpdated) {
			return 0;
		}
		PreparedStatement lStat = aConn.prepareStatement("UPDATE taxon SET taxonid = ?, species = ?, filename = ? WHERE taxonid = ?");
		lStat.setLong(1, iTaxonid);
		lStat.setObject(2, iSpecies);
		lStat.setObject(3, iFilename);
		lStat.setLong(4, iTaxonid);
		int result = lStat.executeUpdate();
		lStat.close();
		this.iUpdated = false;
		return result;
	}


	/**
	 * This method allows the caller to insert the data represented by this
	 * object in a persistent store.
	 *
	 * @param   aConn Connection to the persitent store.
	 */
	public int persist(Connection aConn) throws SQLException {
		PreparedStatement lStat = aConn.prepareStatement("INSERT INTO taxon (taxonid, species, filename) values(?, ?, ?)");
		if(iTaxonid == Long.MIN_VALUE) {
			lStat.setNull(1, 4);
		} else {
			lStat.setLong(1, iTaxonid);
		}
		if(iSpecies == null) {
			lStat.setNull(2, 12);
		} else {
			lStat.setObject(2, iSpecies);
		}
		if(iFilename == null) {
			lStat.setNull(3, 12);
		} else {
			lStat.setObject(3, iFilename);
		}
		int result = lStat.executeUpdate();

		// Retrieving the generated keys (if any).
		ResultSet lrsKeys = lStat.getGeneratedKeys();
		ResultSetMetaData lrsmKeys = lrsKeys.getMetaData();
		int colCount = lrsmKeys.getColumnCount();
		iKeys = new Object[colCount];
		while(lrsKeys.next()) {
			for(int i=0;i<iKeys.length;i++) {
				iKeys[i] = lrsKeys.getObject(i+1);
			}
		}
		lrsKeys.close();
		lStat.close();
		// Verify that we have a single, generated key.
		if(iKeys != null && iKeys.length == 1 && iKeys[0] != null) {
			// Since we have exactly one key specified, and only
			// one Primary Key column, we can infer that this was the
			// generated column, and we can therefore initialize it here.
			iTaxonid = ((Number) iKeys[0]).longValue();
		}
		this.iUpdated = false;
		return result;
	}

	/**
	 * This method will return the automatically generated key for the insert if 
	 * one was triggered, or 'null' otherwise.
	 *
	 * @return	Object[]	with the generated keys.
	 */
	public Object[] getGeneratedKeys() {
		return this.iKeys;
	}

}