package com.compomics.proteocloud.model;
public class SpectrumMatch {

    /**
     * Flag denoting whether this match is selected for export.
     */
    private boolean selected = true;

    /**
     * The search spectrum id;
     */
    protected long spectrumId;

    /**
     * Default empty constructor.
     */
    public SpectrumMatch() { }

    /**
     * Returns the spectrum specific id.
     * @return The spectrum id.
     */
    public long getSpectrumId() {
        return spectrumId;
    }

    /**
     * Sets the search spectrum id.
     * @param spectrumId The search spectrum id
     */
    public void setSpectrumId(long spectrumId) {
        this.spectrumId = spectrumId;
    }

    /**
     * Returns whether this spectrum match is selected for exporting.
     * @return <code>true</code> if match is selected for export,
     * <code>false</code> otherwise.
     */
    public boolean isSelected() {
        return selected;
    }

    /**
     * Sets whether this spectrum match is selected for exporting.
     * @param selected <code>true</code> if match is selected for export,
     * <code>false</code> otherwise.
     */
    public void setSelected(boolean selected) {
        this.selected = selected;
    }

    @Override
    public String toString() {
        return "[ssID = " + spectrumId + "]";
    }
}
