package com.compomics.proteocloud.s3;

import java.util.Date;

/**
 * This container class represents a stored object in the S3 database.
 * It's used for the table updating functionality in the UI. 
 * @author Thilo Muth
 *
 */
public class StorageObject {
	/**
	 * The file's name.
	 */
	private String filename;
	
	/**
	 * The size of the file in bytes.
	 */
	private long size;
	
	/**
	 * The last modified timestamp.
	 */
	private Date lastModified;
	
	/**
	 * Default constructor for the StorageObject.
	 */
	public StorageObject() {
	}
	
	/**
	 * The constructor for the StorageObject with field parameters.
	 * @param filename The file name.
	 * @param size The size of the storage object.
	 * @param lastModified Last modified date.
	 */
	public StorageObject(String filename, long size, Date lastModified) {
		this.filename = filename;
		this.size = size;
		this.lastModified = lastModified;
	}
	
	public String getFilename() {
		return filename;
	}
	public void setFilename(String filename) {
		this.filename = filename;
	}
	public long getSize() {
		return size;
	}
	public void setSize(long size) {
		this.size = size;
	}
	public Date getLastModified() {
		return lastModified;
	}
	public void setLastModified(Date lastModified) {
		this.lastModified = lastModified;
	}
}
