package com.compomics.proteocloud.sqs;

/**
 * This container class represents a queue object from the SQS.
 *  
 * @author Thilo Muth
 *
 */
public class MessageObject {
	
	/**
	 * The message's id.
	 */
	private String messageid;
	
	/**
	 * The message's body.
	 */
	private String messagebody;	
	
	/**
	 * The message's receipt handle.
	 */
	private String receipthandle;
	
	/**
	 * Default constructor for the queue object.
	 */
	public MessageObject() {
	}
	
	/**
	 * The constructor for the QueueObject with field parameters.	
	 * @param messageid The message id.
     * @param messagebody The message body.
     * @param receipthandle The receipt handle.
     *
	 */
	public MessageObject(String messageid, String messagebody, String receipthandle) {
		this.messageid = messageid;
		this.messagebody = messagebody;
		this.receipthandle = receipthandle;
	}

	/**
	 * Returns the message body.
	 * @return messagebody 
	 */
	public String getMessageBody() {
		return messagebody;
	}
	
	/**
	 * Sets the message body.
	 * @param messagebody
	 */
	public void setMessageBody(String messagebody) {
		this.messagebody = messagebody;
	}
	
	/**
	 * Returns the message id.
	 * @return
	 */
	public String getMessageid() {
		return messageid;
	}
	
	/**
	 * Sets the message id.
	 * @param messageid
	 */
	public void setMessageid(String messageid) {
		this.messageid = messageid;
	}
	
	/**
	 * Returns the message receipt handle.
	 * @return receipthandle
	 */
	public String getReceipthandle() {
		return receipthandle;
	}
	
	/**
	 * Sets the message receipt handle.
	 * @param receipthandle
	 */
	public void setReceipthandle(String receipthandle) {
		this.receipthandle = receipthandle;
	}
	
}
