package com.compomics.proteocloud.ui;

import com.jgoodies.looks.HeaderStyle;
import com.jgoodies.looks.Options;

import javax.swing.*;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Toolkit;

/**
 * PropertiesUI defines some constants for the user interface.
 * @author Thilo Muth
 *
 */
public class PropertiesUI {
	
	/**
	 * Title of the application
	 */
	public final static String APPTITLE = "ProteoCloud";
	
	/**
	 * Version of the application.
	 */
	public final static String VERSION = "1.1";
	
	/**
	 * Width of the main frame.
	 */
	public static final int FRAMEWIDTH = 1280;
	
	/**
	 * Height of the main frame.
	 */
	public static final int FRAMEHEIGHT = 820;
	
	/**
	 * The chunk default value.
	 */
	public static final int CHUNK_DEFAULT_VALUE = 1000;
	
	/**
	 * Center the given component in the visible screen.
	 * 
	 * @param aComponent
	 */
	public static void centerInScreen(Component aComponent) {
		Dimension tDim = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (tDim.width - aComponent.getSize().width) / 2;
		int y = (tDim.height - aComponent.getSize().height) / 2;
		aComponent.setLocation(x, y);
	}
}
